# json-to-table-pagination

When an array of JSON objects is passed to json-to-table-pagination, it will return the json values in a table format
and also adds pagination to it. You can pass background color as options. To display words in the buttons instead of
arrows set the 'useArrowIcons' to false.

[![NPM](https://img.shields.io/npm/v/json-to-table-pagination.svg)](https://www.npmjs.com/package/json-to-table-pagination) [![JavaScript Style Guide](https://img.shields.io/badge/code_style-standard-brightgreen.svg)](https://standardjs.com)

## Install

```bash
npm install --save json-to-table-pagination
```

## Usage

```jsx
import React from 'react'
import { JSONToTable } from 'json-to-table-pagination'

const App = () => {
    const users = [
        {
            id: '111',
            firstname: 'Ram',
            lastname: 'Akunuru',
            email: 'ram@gmail.com'
        },
        {
            id: '222',
            firstname: 'Tony',
            lastname: 'Stark',
            email: 'tony@gmail.com'
        },
        {
            id: '333',
            firstname: 'Captain',
            lastname: 'America',
            email: 'captain@gmail.com'
        }
    ]
    const options = {
        bgColor: '#1B5E20',
        useArrowIcons: false
    }

    return <JSONToTable jsonFile={users} options={options} />
}

export default App
```

![Alt text](https://github.com/RamAkunuru/images/blob/master/blue.png?raw=true 'Blue Table')
![Alt text](https://github.com/RamAkunuru/images/blob/master/green.png?raw=true 'Green Table')

## License

MIT © [](https://github.com/)
