import React, { useState } from 'react';
import 'bootstrap/dist/css/bootstrap.css';
import { BsChevronDoubleLeft, BsChevronLeft, BsChevronRight, BsChevronDoubleRight } from 'react-icons/bs';
import styled from 'styled-components';

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

var PRIMARY = '#1E88E5';
var FIRST = 'First';
var LAST = 'Last';
var PREVIOUS = 'Previous';
var NEXT = 'NEXT';

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n    list-style: none;\n    display: flex;\n    justify-content: center;\n    margin-bottom: 0;\n\n    li {\n        align-items: center;\n        border: 1px solid white;\n        cursor: pointer;\n        display: flex;\n        font-weight: bold;\n        margin-right: 2rem;\n        padding: 0.5rem;\n    }\n\n    li:third-child {\n        cursor: none;\n    }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n    display: flex;\n    justify-content: space-around;\n    padding: 0.5rem;\n    border-radius: 0;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n    width: 5rem;\n    padding: 0.5rem;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n    align-items: center;\n    display: flex;\n    padding-left: 1.3rem;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n    background-color: ", ";\n    color: white;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var PaginationWrapper = styled.div(_templateObject(), function (props) {
  return props.bgColor ? props.bgColor : PRIMARY;
});
var PaginationRowsWrapper = styled.div(_templateObject2());
var PaginationSelect = styled.select(_templateObject3());
var PaginationNav = styled.nav(_templateObject4());
var PaginationList = styled.ul(_templateObject5());

var Pagination = (function (_ref) {
  var currentPage = _ref.currentPage,
      getNextPage = _ref.getNextPage,
      getPreviousPage = _ref.getPreviousPage,
      getFirstPage = _ref.getFirstPage,
      getLastPage = _ref.getLastPage,
      displayRowsPerPage = _ref.displayRowsPerPage,
      bgColor = _ref.bgColor,
      _ref$useArrowIcons = _ref.useArrowIcons,
      useArrowIcons = _ref$useArrowIcons === void 0 ? true : _ref$useArrowIcons;
  return /*#__PURE__*/React.createElement(PaginationWrapper, {
    className: "row",
    bgColor: bgColor
  }, /*#__PURE__*/React.createElement(PaginationRowsWrapper, {
    className: "col-md-1"
  }, /*#__PURE__*/React.createElement(PaginationSelect, {
    onChange: displayRowsPerPage
  }, /*#__PURE__*/React.createElement("option", {
    value: "5"
  }, "5"), /*#__PURE__*/React.createElement("option", {
    value: "10"
  }, "10"), /*#__PURE__*/React.createElement("option", {
    value: "25"
  }, "25"), /*#__PURE__*/React.createElement("option", {
    value: "50"
  }, "50"), /*#__PURE__*/React.createElement("option", {
    value: "100"
  }, "100"))), /*#__PURE__*/React.createElement(PaginationNav, {
    className: "col-md-11 pagination"
  }, /*#__PURE__*/React.createElement(PaginationList, {
    className: "pagination-list"
  }, /*#__PURE__*/React.createElement("li", {
    onClick: function onClick() {
      return getFirstPage();
    }
  }, useArrowIcons ? /*#__PURE__*/React.createElement(BsChevronDoubleLeft, null) : FIRST), /*#__PURE__*/React.createElement("li", {
    onClick: function onClick() {
      return getPreviousPage();
    }
  }, useArrowIcons ? /*#__PURE__*/React.createElement(BsChevronLeft, null) : PREVIOUS), /*#__PURE__*/React.createElement("li", {
    className: "current-page"
  }, currentPage), /*#__PURE__*/React.createElement("li", {
    onClick: function onClick() {
      return getNextPage();
    }
  }, useArrowIcons ? /*#__PURE__*/React.createElement(BsChevronRight, null) : NEXT), /*#__PURE__*/React.createElement("li", {
    onClick: function onClick() {
      return getLastPage();
    }
  }, useArrowIcons ? /*#__PURE__*/React.createElement(BsChevronDoubleRight, null) : LAST))));
});

function _templateObject2$1() {
  var data = _taggedTemplateLiteralLoose(["\n    border: 1px solid #fafafa;\n"]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$1() {
  var data = _taggedTemplateLiteralLoose(["\n    text-transform: capitalize;\n    background-color: ", ";\n    color: white;\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var TableHead = styled.thead(_templateObject$1(), function (props) {
  return props.bgColor ? props.bgColor : PRIMARY;
});
var CustomTable = styled.div(_templateObject2$1());

var CustomTable$1 = (function (_ref) {
  var jsonFile = _ref.jsonFile,
      options = _ref.options;
  var bgColor = options.bgColor,
      useArrowIcons = options.useArrowIcons;

  var _useState = useState(1),
      currentPage = _useState[0],
      setCurrentPage = _useState[1];

  var _useState2 = useState(5),
      rowsPerPage = _useState2[0],
      setRowsPerPage = _useState2[1];

  var totalPages = Math.ceil(jsonFile.length / rowsPerPage);
  var indexOfLastRow = currentPage * rowsPerPage;
  var indexOfFirstRow = indexOfLastRow - rowsPerPage;
  var currentRecords = jsonFile.slice(indexOfFirstRow, indexOfLastRow);
  var tableHeaders = currentRecords.length ? Object.keys(currentRecords[0]) : [];

  var renderTableRows = function renderTableRows() {
    return currentRecords.map(function (currentRecord, index) {
      return /*#__PURE__*/React.createElement("tr", {
        key: index.toString()
      }, tableHeaders.map(function (header, indexKey) {
        return /*#__PURE__*/React.createElement("td", {
          key: indexKey.toString()
        }, currentRecord[header]);
      }));
    });
  };

  var renderTableHeader = function renderTableHeader() {
    return tableHeaders.map(function (header, index) {
      return /*#__PURE__*/React.createElement("th", {
        key: index.toString()
      }, header);
    });
  };

  var getNextPage = function getNextPage() {
    if (currentPage !== totalPages) {
      setCurrentPage(currentPage + 1);
    }
  };

  var getPreviousPage = function getPreviousPage() {
    if (currentPage !== 1) {
      setCurrentPage(currentPage - 1);
    }
  };

  var getFirstPage = function getFirstPage() {
    return setCurrentPage(1);
  };

  var getLastPage = function getLastPage() {
    return setCurrentPage(totalPages);
  };

  var displayRowsPerPage = function displayRowsPerPage(e) {
    setRowsPerPage(e.target.value);
    setCurrentPage(1);
  };

  return /*#__PURE__*/React.createElement(CustomTable, null, /*#__PURE__*/React.createElement("table", {
    className: "table table-hover table-striped"
  }, /*#__PURE__*/React.createElement(TableHead, {
    bgColor: bgColor
  }, /*#__PURE__*/React.createElement("tr", null, renderTableHeader())), /*#__PURE__*/React.createElement("tbody", null, renderTableRows())), /*#__PURE__*/React.createElement(Pagination, {
    currentPage: currentPage,
    getNextPage: getNextPage,
    getPreviousPage: getPreviousPage,
    getFirstPage: getFirstPage,
    getLastPage: getLastPage,
    displayRowsPerPage: displayRowsPerPage,
    bgColor: bgColor,
    useArrowIcons: useArrowIcons
  }));
});

var JSONToTable = function JSONToTable(_ref) {
  var jsonFile = _ref.jsonFile,
      options = _ref.options;
  return /*#__PURE__*/React.createElement(CustomTable$1, {
    jsonFile: jsonFile,
    options: options
  });
};

export { JSONToTable };
//# sourceMappingURL=index.modern.js.map
